# $Id: modsidentifierfield.py 3734 2010-06-08 22:07:29Z place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/trunk/sources/meresco/bzv/src/modsidentifierfield.py $

from merescocore.framework import Observable

class ModsIdentifierField(Observable):

    def __init__(self):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}

    def addXml(self, lxmlNode):
        identifiers = lxmlNode.xpath('//mods:identifier/@displayLabel', namespaces=self._namespaceMap)
        if len(identifiers) > 0:
            for identifier in identifiers:
                yield self.all.addField(name='mods.identifier', value=identifier)
                yield self.all.addField(name='mods', value=identifier)
